﻿Public Class Car
    'フィールド==========
    'Public m_speed As Integer　　　　　'スピード情報
    Private m_speed As Integer     'スピード情報(修正)

    'Public m_gas As Double　　　　　'ガソリン情報
    Private m_gas As Double     'ガソリン情報(修正)

    'プロパティ==========
    'スピード参照用
    Public ReadOnly Property Speed As Integer
        Get
            Return Me.m_speed
        End Get
    End Property

    'ガソリン参照・設定用
    Public Property Gas As Double
        Get
            Return Me.m_gas
        End Get
        Set(value As Double)
            If Value > 0 Then
                Me.m_gas = Value
            Else
                Me.m_gas = 0
            End If
        End Set
    End Property

    'コンストラクタ===========
    Public Sub New()
        Me.New(20)
    End Sub

    Public Sub New(gas As Double)
        Me.m_speed = 0
        Me.m_gas = gas
    End Sub

    'メソッド==========
    '加速させるメソッド
    Public Sub SpeedUp(ByVal sp As Integer)
        Me.m_speed += sp
        Me.m_gas -= sp / 10     '加速するとガソリンが減る
    End Sub

    '減速させるメソッド
    Public Sub SpeedDown(sp As Integer)
        Me.m_speed -= sp        '減速した場合はガソリンは消費しない
        If Me.m_speed < 0 Then
            Me.m_speed = 0
        End If
    End Sub

    '初期化を行うメソッド
    Public Sub Init(gas As Double)
        Me.m_speed = 0
        Me.m_gas = gas
    End Sub

    ''スピードを取得する
    'Public Function GetSpeed() As Integer
    '    Return Me.m_speed
    'End Function

    ''ガソリン量を取得する
    'Public Function GetGas() As Double
    '    Return Me.m_gas
    'End Function
End Class
